package com.ieso.secureClient;

import static org.junit.Assert.assertEquals;

import java.net.Authenticator;
import java.net.MalformedURLException;
import java.net.PasswordAuthentication;
import java.util.Map;

import javax.xml.ws.BindingProvider;

import org.junit.Test;

import com.ieso.securityws.SecureWs;
import com.ieso.securityws.SecureWsService;

public class TestSecureClient {
	private String word = "Hello";
	private String echo = word +" "+word;
	
	private static SecureWs getPort(final String user, final String pass) throws MalformedURLException{
		Authenticator.setDefault(new Authenticator() {
			protected PasswordAuthentication getPasswordAuthentication() {
				return new PasswordAuthentication (user, pass.toCharArray());
			}
		 });
		
		SecureWs port = new SecureWsService().getSecureWsPort();
		
		Map<String, Object> reqContext = ((BindingProvider) port).getRequestContext();
		reqContext.put(BindingProvider.USERNAME_PROPERTY, user);
		reqContext.put(BindingProvider.PASSWORD_PROPERTY, pass);
		
		return port;
	}
	
	@Test
	public void testRightCredentials() throws MalformedURLException{
		assertEquals(getPort("kermit","thefrog").echo(word), echo);
	}
	
	@Test
	public void testWrongCredentials() throws MalformedURLException{
		assertEquals(getPort("ralph","thedog").echo(word), echo);
	}	
}
